/*****************************************************
Project : 16x16 Ʈ Ʈ ⺻  
Version : V02
Date    : 2013-01-28
Compiler: CodevisionAVR + AVR Studio
Author  : LKEMBEDDED
Company : LKEMBEDDED
Comments: 16x 16 ƮƮ ⿡ "LK" ڰ Ǵ α׷̴.

10p ÷ ̺  Ʒ  ּ!

ATmega128ߺ B,C PORTD <-------------> 16X16 ƮƮ  - 10pڽĿ (PORT0)
ATmega128ߺ B,C PORTC <-------------> 16X16 ƮƮ  - 10pڽĿ (PORT1)

*****************************************************/

#include <mega128.h>
#include <delay.h>
#define LOW_CLK_ORANGE_0 ~(0X41)
#define LOW_CLK_ORANGE_1 ~(0X42)
#define LOW_CLK_RED_0 ~(0X44)
#define LOW_CLK_RED_1 ~(0X48)

#define LOW_ROW_0 ~(0X50)
#define LOW_ROW_1 ~(0X60)
#define High_CP 0x3f
#define OC  PORTC.6 //ADD Function! Output On/Off 

flash unsigned int row[]={0x00001,0x00002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000,};
flash unsigned int col[]={0x00,0x00,0x6306,0x3306,0x1b06,0xf06,0x706,0xf06,0x1b06,0x3306,0x637e,0x637e,0x00,0x00,0x00,0x00}; //LK

 
unsigned int Color;  
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
static int i=0;
i++;
if(i==500)
{
       i=0;
       Color++;
       if(Color==3)
       {
       Color=0;
       }
}
        TCNT0+=6;
} 
        

void row0_on()//LED`s Common Anode 0~7 
{
PORTC=LOW_ROW_0;PORTC=High_CP; //U9 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void row1_on() //LED`s Common Anode 8~15        
{
PORTC=LOW_ROW_1;PORTC=High_CP; //U11 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void column0_Red_led_on()//Red LED cathode 0~7      
{
PORTC=LOW_CLK_RED_0;PORTC=High_CP; //U5 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void column1_Red_led_on()//Red LED cathode 8~15       
{
PORTC=LOW_CLK_RED_1;PORTC=High_CP;//U7 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition) 
}

void column0_Orange_led_on()//Orange LED cathode 0~7  
{
PORTC=LOW_CLK_ORANGE_0;PORTC=High_CP; //U1 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)
}

void column1_Orange_led_on()//Orange LED cathode 0~7  
{
PORTC=LOW_CLK_ORANGE_1;PORTC=High_CP; //U3 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition) 
}

void Dot_Full_Test() //At intervals of 0.1 seconds 74hc574 Check the status of the operation!
{
    PORTD=0XFF; // LED`s Common Anode 0~7    
    row0_on();
    PORTD=0XFF; // LED`s Common Anode 8~15        
    row1_on();
      
    PORTD=0xff; // Yellow LED cathode 0~7  
    column0_Orange_led_on();           
    PORTD=0xff; // Yellow LED cathode8~15       
    column1_Orange_led_on();  
    
    PORTD=0X00; // Red LED cathode 0~7    
    column0_Red_led_on();  
    PORTD=0X00; // Red LED cathode 8~15    
    column1_Red_led_on();        
   
    delay_ms(100);    
    
    PORTD=0X00; //LED`s Common Anode 0~7    
    row0_on();
    PORTD=0X00; //LED`s Common Anode 8~15        
    row1_on();
      
    PORTD=0xff; // Yellow LED cathode 0~7  
    column0_Orange_led_on();           
    PORTD=0xff; // Yellow LED cathode8~15       
    column1_Orange_led_on();  
    
    PORTD=0Xff; // Red LED cathode 0~7    
    column0_Red_led_on();  
    PORTD=0Xff; // Red LED cathode 8~15    
    column1_Red_led_on();               
    delay_ms(100);      
}
void main(void)
{
   
    //-- Ʈ ʱȭ! 
    DDRD=0xFF; //ƮƮ ͹(DB0~DB7)  !       
    DDRC=0x7F; //ƮƮ  (CLK_ORANGE0~CLK_ROW1)  !       
    OC=0; //Output On!    
    
     //---Timer/Counter Interrupt initalize
    TCCR0=0X04; //Overflow Interrupt, 64Prescaler Select
    TCNT0=6;    //Timer Counter Register set                                               
    TIMSK=1;    //Oveflow interrupt enable
    SREG=0X80;  //Global interrupt enable bit set     
   
    while(1) //Endless Loop
    {                              
    static unsigned int i,j=0; 
    unsigned int col_a,row_a=0;                    
    switch(Color)
    {
    case 0: 
        for(j=0;j<16;j++){
          
        row_a=row[j]; 
        PORTD=(row_a&0xff);      
        row0_on();
        PORTD=(row_a>>8);   
        row1_on();    
        
        col_a=col[j];     
        PORTD=(col_a&0xff); ; // Yellow LED cathode 0~7  
        column0_Red_led_on();
        PORTD=(col_a>>8);   ; //Yellow LED cathode8~15       
        column1_Red_led_on();
           
        PORTD=0x00;     
        column0_Orange_led_on();       
        PORTD=0x00;        
        column1_Orange_led_on();
        delay_ms(1); 
        }
        break;
    
    case 1:
        for(j=0;j<16;j++){
          
        row_a=row[j]; 
        PORTD=(row_a&0xff);      
        row0_on();
        PORTD=(row_a>>8);   
        row1_on();    
        
        col_a=col[j];     
        PORTD=(col_a&0xff); ; // Yellow LED cathode 0~7  
        column0_Orange_led_on();
        PORTD=(col_a>>8);   ; //Yellow LED cathode8~15       
        column1_Orange_led_on();
             
        PORTD=0x00;     
        column0_Red_led_on();       
        PORTD=0x00;        
        column1_Red_led_on();
        delay_ms(1);      
        }   
        break;
    case 2:  
       for(j=0;j<16;j++){
          
        row_a=row[j]; 
        PORTD=(row_a&0xff);      
        row0_on();
        PORTD=(row_a>>8);   
        row1_on();    
        
        col_a=col[j];     
        PORTD=(col_a&0xff); ; 
        column0_Orange_led_on();
        PORTD=(col_a>>8);   ;  
        column1_Orange_led_on();
      
        PORTD=(col_a&0xff); ;    
        column0_Red_led_on();          
        PORTD=(col_a>>8);   
        column1_Red_led_on();   
        delay_ms(1);    
        }  
        break;
      }

   }
  }
