/*****************************************************
Project : 16x16 Ʈ Ʈ ⺻  
Version : V02
Date    : 2013-01-28
Compiler: CodevisionAVR + AVR Studio
Author  : LKEMBEDDED
Company : LKEMBEDDED
Comments: 16x 16 ƮƮ LED⿡  LED ϳ Ǵ α׷̴.

10p ÷ ̺  Ʒ  ּ!

ATmega128Ȯ ߺ B,C PORTD <-------------> 16X16 ƮƮ  - 10pڽĿ (PORT0)
ATmega128Ȯ ߺ B,C PORTC <-------------> 16X16 ƮƮ  - 10pڽĿ (PORT1)

*****************************************************/

#include <mega128.h>
#include <delay.h>
#define LOW_CLK_ORANGE_0 ~(0X41)
#define LOW_CLK_ORANGE_1 ~(0X42)
#define LOW_CLK_RED_0 ~(0X44)
#define LOW_CLK_RED_1 ~(0X48)

#define LOW_ROW_0 ~(0X50)
#define LOW_ROW_1 ~(0X60)
#define High_CP 0x3f
#define OC  PORTC.6 //ADD Function! Output On/Off 


void row0_on()//LED`s Common Anode 0~7 
{
PORTC=LOW_ROW_0;PORTC=High_CP; //U9 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void row1_on() //LED`s Common Anode 8~15        
{
PORTC=LOW_ROW_1;PORTC=High_CP; //U11 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void column0_Red_led_on()//Red LED cathode 0~7      
{
PORTC=LOW_CLK_RED_0;PORTC=High_CP; //U5 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)  
}

void column1_Red_led_on()//Red LED cathode 8~15       
{
PORTC=LOW_CLK_RED_1;PORTC=High_CP;//U7 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition) 
}

void column0_Orange_led_on()//Orange LED cathode 0~7  
{
PORTC=LOW_CLK_ORANGE_0;PORTC=High_CP; //U1 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition)
}

void column1_Orange_led_on()//Orange LED cathode 0~7  
{
PORTC=LOW_CLK_ORANGE_1;PORTC=High_CP; //U3 74HC574(8 flip-flops)Ŭȣ ȣ(LOW-to-HIGH CP Transition) 
}

void Dot_Full_Test() //At intervals of 0.1 seconds 74hc574 Check the status of the operation!
{
    PORTD=0XFF; // LED`s Common Anode 0~7    
    row0_on();
    PORTD=0XFF; // LED`s Common Anode 8~15        
    row1_on();
      
    PORTD=0xff; // Yellow LED cathode 0~7  
    column0_Orange_led_on();           
    PORTD=0xff; // Yellow LED cathode8~15       
    column1_Orange_led_on();  
    
    PORTD=0X00; // Red LED cathode 0~7    
    column0_Red_led_on();  
    PORTD=0X00; // Red LED cathode 8~15    
    column1_Red_led_on();        
   
    delay_ms(100);    
    
    PORTD=0X00; //LED`s Common Anode 0~7    
    row0_on();
    PORTD=0X00; //LED`s Common Anode 8~15        
    row1_on();
      
    PORTD=0xff; // Yellow LED cathode 0~7  
    column0_Orange_led_on();           
    PORTD=0xff; // Yellow LED cathode8~15       
    column1_Orange_led_on();  
    
    PORTD=0Xff; // Red LED cathode 0~7    
    column0_Red_led_on();  
    PORTD=0Xff; // Red LED cathode 8~15    
    column1_Red_led_on();               
    delay_ms(100);      
}
void Dot_Test() //At intervals of 0.1 seconds 74hc574 Check the status of the operation!
{
    PORTD=0X01; // LED`s Common Anode 0~7    
    row0_on();
    PORTD=0X00; // LED`s Common Anode 8~15        
    row1_on();
      
    PORTD=0x00; // Yellow LED cathode 0~7  
    column0_Orange_led_on();                                              

    PORTD=0x00; // Yellow LED cathode8~15       
    column1_Orange_led_on();          
    
    PORTD=0X01; // Red LED cathode 0~7    
    column0_Red_led_on();              
    
    PORTD=0X00; // Red LED cathode 8~15    
    column1_Red_led_on();       
}
void main(void)
{
   
    //-- Ʈ ʱȭ! 
    DDRD=0xFF; //ƮƮ ͹(DB0~DB7)  !       
    DDRC=0x7F; //ƮƮ  (CLK_ORANGE0~CLK_ROW1)  !       
    OC=0; //Output On!    
       
    while(1) //Endless Loop
    {                              
    Dot_Test();
    }
  }
